﻿using System;
using System.Xml.Serialization;

namespace GCHR.Model.Konto
{
    public class Saldo
    {
        #region veraltet

        /// <summary>veraltet</summary>
        [XmlAttribute("name")]
        public string Name
        {
            set { Periode = value; }
            get { return null; }
        }

        /// <summary>veraltet</summary>
        [XmlAttribute("wert")]
        public string Wert
        {
            set { Soll = Decimal.Parse(value, Constants.ZahlenformatImport); }
            get { return null; }
        }

        #endregion

        [XmlAttribute("Periode")]
        public string Periode;


        [XmlAttribute("Soll")]
        public decimal Soll;

        [XmlAttribute("Haben")]
        public decimal Haben;

        [XmlIgnore]
        public string SaldoCsv
        {
            get { return Periode + ";" + Soll + ";" + Haben + Environment.NewLine; }
        }

        [XmlIgnore]
        public decimal Summe { get { return Soll + Haben; } }
    }
}
