﻿using System;
using System.Text;
using GCHR.Model.Konto;

namespace GCHR.Model.Mandant
{
    class Csv : IMandant
    {
        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return true;
            }
        }

        public string BalanceHeader
        {
            get 
            { 
                return "Konto_Nr;Saldo;Konto_Bezeichnung";
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string BalanceBody(HaendlerKonto kto)
        {
            return KontonummerFormatieren(kto) + ";" + kto.Summe + ";" + kto.Bezeichnung;
        }


        public string AccountsHeader
        {
            get
            {
                return "Konto_Nr;Konto_Bezeichnung";
            }
        }

        public string AccountsBody(HaendlerKonto kto)
        {
            return KontonummerFormatieren(kto) + ";" + kto.Bezeichnung;
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }
        }

        public string KontonummerFormatieren(HaendlerKonto konto)
        {
            return konto.Marke + konto.Betrieb + konto.Kontonummer;
        }

        public Encoding Encoding
        {
            get { return Encoding.Default; }
        }
    }
}
