﻿using GCHR.Model;

namespace GCHR.Control.IO
{
    class GchrConfigIO : ConfigIO
    {
        public GchrConfigIO(string datei) : base(datei, typeof(GchrConfig))
        {
        }

        public override object Laden()
        {
            var config = (GchrConfig)DateiLaden() ?? NeueInstanz();
            VersionsUpdate(config);
            return config;
        }

        private static void VersionsUpdate(GchrConfig config)
        {
            config.Einstellungen.Steuerungsdateien = null;
        }

        private static GchrConfig NeueInstanz()
        {
            return new GchrConfig();
        }
    }
}
