﻿using System.Globalization;
using System.Text;

namespace GCHR.Model
{
    internal static class Constants
    {
        private static readonly byte[] Key = {76, 123, 122, 84, 45, 12, 44, 78, 56, 43, 47, 6, 
              2, 13, 23, 23, 45, 255, 65, 20, 33, 5, 235, 66};
        private static readonly byte[] Iv = { 56, 254, 98, 123, 66, 4, 90, 34, 111, 34, 78, 33, 222, 80, 74, 35 };

        internal static string Encrypt(string toenc)
        {
            var des = new CTripleDes(Key, Iv);
            return des.Encrypt(toenc);
        }

        internal static string Decrypt(string todec)
        {
            var des = new CTripleDes(Key, Iv);
            return des.Decrypt(todec);
        }

        public static Encoding CsvEncoding = Encoding.Default;

        public static string ConfigDatei = "config\\gchr.xml";
        public const string ConfigDateiAlt = "config\\config.xml";

        public const string DepartmentFilter = "'01','1'";

        public static NumberFormatInfo Zahlenformat = CultureInfo.GetCultureInfo("de-DE").NumberFormat;
        public static NumberFormatInfo ZahlenformatImport = CultureInfo.GetCultureInfo("en-US").NumberFormat;
    }
}
